/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_AMQP_ClientOperations__
#define qpid_framing_AMQP_ClientOperations__

#include <sstream>

#include "qpid/framing/ProtocolVersion.h"

namespace qpid {
namespace framing {

class MethodContext;

class AMQP_ClientOperations
{
public:
    virtual ~AMQP_ClientOperations() {}

    virtual ProtocolVersion getVersion() const = 0;

    // Include framing constant declarations
    #include "AMQP_Constants.h"

    // Inner classes

    // ==================== class AccessHandler ====================
    class AccessHandler
    {
        // Constructors and destructors
    public:
        AccessHandler(){};
        virtual ~AccessHandler() {}

        // Protocol methods

        virtual void requestOk(const MethodContext& context,
                            u_int16_t ticket ) = 0;
    }; // class AccessHandler

    // ==================== class BasicHandler ====================
    class BasicHandler
    {
        // Constructors and destructors
    public:
        BasicHandler(){};
        virtual ~BasicHandler() {}

        // Protocol methods

        virtual void cancelOk(const MethodContext& context,
                            const string& consumerTag ) = 0;

        virtual void consumeOk(const MethodContext& context,
                            const string& consumerTag ) = 0;

        virtual void deliver(const MethodContext& context,
                            const string& consumerTag,
                            u_int64_t deliveryTag,
                            bool redelivered,
                            const string& exchange,
                            const string& routingKey ) = 0;

        virtual void getEmpty(const MethodContext& context,
                            const string& clusterId ) = 0;

        virtual void getOk(const MethodContext& context,
                            u_int64_t deliveryTag,
                            bool redelivered,
                            const string& exchange,
                            const string& routingKey,
                            u_int32_t messageCount ) = 0;

        virtual void qosOk(const MethodContext& context ) = 0;

        virtual void return_(const MethodContext& context,
                            u_int16_t replyCode,
                            const string& replyText,
                            const string& exchange,
                            const string& routingKey ) = 0;
    }; // class BasicHandler

    // ==================== class ChannelHandler ====================
    class ChannelHandler
    {
        // Constructors and destructors
    public:
        ChannelHandler(){};
        virtual ~ChannelHandler() {}

        // Protocol methods

        virtual void close(const MethodContext& context,
                            u_int16_t replyCode,
                            const string& replyText,
                            u_int16_t classId,
                            u_int16_t methodId ) = 0;

        virtual void closeOk(const MethodContext& context ) = 0;

        virtual void flow(const MethodContext& context,
                            bool active ) = 0;

        virtual void flowOk(const MethodContext& context,
                            bool active ) = 0;

        virtual void ok(const MethodContext& context ) = 0;

        virtual void openOk(const MethodContext& context,
                            const string& channelId ) = 0;

        virtual void ping(const MethodContext& context ) = 0;

        virtual void pong(const MethodContext& context ) = 0;
    }; // class ChannelHandler

    // ==================== class ConnectionHandler ====================
    class ConnectionHandler
    {
        // Constructors and destructors
    public:
        ConnectionHandler(){};
        virtual ~ConnectionHandler() {}

        // Protocol methods

        virtual void close(const MethodContext& context,
                            u_int16_t replyCode,
                            const string& replyText,
                            u_int16_t classId,
                            u_int16_t methodId ) = 0;

        virtual void closeOk(const MethodContext& context ) = 0;

        virtual void openOk(const MethodContext& context,
                            const string& knownHosts ) = 0;

        virtual void redirect(const MethodContext& context,
                            const string& host,
                            const string& knownHosts ) = 0;

        virtual void secure(const MethodContext& context,
                            const string& challenge ) = 0;

        virtual void start(const MethodContext& context,
                            u_int8_t versionMajor,
                            u_int8_t versionMinor,
                            const FieldTable& serverProperties,
                            const string& mechanisms,
                            const string& locales ) = 0;

        virtual void tune(const MethodContext& context,
                            u_int16_t channelMax,
                            u_int32_t frameMax,
                            u_int16_t heartbeat ) = 0;
    }; // class ConnectionHandler

    // ==================== class DtxHandler ====================
    class DtxHandler
    {
        // Constructors and destructors
    public:
        DtxHandler(){};
        virtual ~DtxHandler() {}

        // Protocol methods

        virtual void selectOk(const MethodContext& context ) = 0;

        virtual void startOk(const MethodContext& context ) = 0;
    }; // class DtxHandler

    // ==================== class ExchangeHandler ====================
    class ExchangeHandler
    {
        // Constructors and destructors
    public:
        ExchangeHandler(){};
        virtual ~ExchangeHandler() {}

        // Protocol methods

        virtual void declareOk(const MethodContext& context ) = 0;

        virtual void deleteOk(const MethodContext& context ) = 0;
    }; // class ExchangeHandler

    // ==================== class FileHandler ====================
    class FileHandler
    {
        // Constructors and destructors
    public:
        FileHandler(){};
        virtual ~FileHandler() {}

        // Protocol methods

        virtual void cancelOk(const MethodContext& context,
                            const string& consumerTag ) = 0;

        virtual void consumeOk(const MethodContext& context,
                            const string& consumerTag ) = 0;

        virtual void deliver(const MethodContext& context,
                            const string& consumerTag,
                            u_int64_t deliveryTag,
                            bool redelivered,
                            const string& exchange,
                            const string& routingKey,
                            const string& identifier ) = 0;

        virtual void open(const MethodContext& context,
                            const string& identifier,
                            u_int64_t contentSize ) = 0;

        virtual void openOk(const MethodContext& context,
                            u_int64_t stagedSize ) = 0;

        virtual void qosOk(const MethodContext& context ) = 0;

        virtual void return_(const MethodContext& context,
                            u_int16_t replyCode,
                            const string& replyText,
                            const string& exchange,
                            const string& routingKey ) = 0;

        virtual void stage(const MethodContext& context ) = 0;
    }; // class FileHandler

    // ==================== class MessageHandler ====================
    class MessageHandler
    {
        // Constructors and destructors
    public:
        MessageHandler(){};
        virtual ~MessageHandler() {}

        // Protocol methods

        virtual void append(const MethodContext& context,
                            const string& reference,
                            const string& bytes ) = 0;

        virtual void checkpoint(const MethodContext& context,
                            const string& reference,
                            const string& identifier ) = 0;

        virtual void close(const MethodContext& context,
                            const string& reference ) = 0;

        virtual void empty(const MethodContext& context ) = 0;

        virtual void offset(const MethodContext& context,
                            u_int64_t value ) = 0;

        virtual void ok(const MethodContext& context ) = 0;

        virtual void open(const MethodContext& context,
                            const string& reference ) = 0;

        virtual void reject(const MethodContext& context,
                            u_int16_t code,
                            const string& text ) = 0;

        virtual void resume(const MethodContext& context,
                            const string& reference,
                            const string& identifier ) = 0;

        virtual void transfer(const MethodContext& context,
                            u_int16_t ticket,
                            const string& destination,
                            bool redelivered,
                            bool immediate,
                            u_int64_t ttl,
                            u_int8_t priority,
                            u_int64_t timestamp,
                            u_int8_t deliveryMode,
                            u_int64_t expiration,
                            const string& exchange,
                            const string& routingKey,
                            const string& messageId,
                            const string& correlationId,
                            const string& replyTo,
                            const string& contentType,
                            const string& contentEncoding,
                            const string& userId,
                            const string& appId,
                            const string& transactionId,
                            const string& securityToken,
                            const FieldTable& applicationHeaders,
                            const Content& body,
                            bool mandatory ) = 0;
    }; // class MessageHandler

    // ==================== class QueueHandler ====================
    class QueueHandler
    {
        // Constructors and destructors
    public:
        QueueHandler(){};
        virtual ~QueueHandler() {}

        // Protocol methods

        virtual void bindOk(const MethodContext& context ) = 0;

        virtual void declareOk(const MethodContext& context,
                            const string& queue,
                            u_int32_t messageCount,
                            u_int32_t consumerCount ) = 0;

        virtual void deleteOk(const MethodContext& context,
                            u_int32_t messageCount ) = 0;

        virtual void purgeOk(const MethodContext& context,
                            u_int32_t messageCount ) = 0;

        virtual void unbindOk(const MethodContext& context ) = 0;
    }; // class QueueHandler

    // ==================== class StreamHandler ====================
    class StreamHandler
    {
        // Constructors and destructors
    public:
        StreamHandler(){};
        virtual ~StreamHandler() {}

        // Protocol methods

        virtual void cancelOk(const MethodContext& context,
                            const string& consumerTag ) = 0;

        virtual void consumeOk(const MethodContext& context,
                            const string& consumerTag ) = 0;

        virtual void deliver(const MethodContext& context,
                            const string& consumerTag,
                            u_int64_t deliveryTag,
                            const string& exchange,
                            const string& queue ) = 0;

        virtual void qosOk(const MethodContext& context ) = 0;

        virtual void return_(const MethodContext& context,
                            u_int16_t replyCode,
                            const string& replyText,
                            const string& exchange,
                            const string& routingKey ) = 0;
    }; // class StreamHandler

    // ==================== class TunnelHandler ====================
    class TunnelHandler
    {
        // Constructors and destructors
    public:
        TunnelHandler(){};
        virtual ~TunnelHandler() {}

        // Protocol methods

    }; // class TunnelHandler

    // ==================== class TxHandler ====================
    class TxHandler
    {
        // Constructors and destructors
    public:
        TxHandler(){};
        virtual ~TxHandler() {}

        // Protocol methods

        virtual void commitOk(const MethodContext& context ) = 0;

        virtual void rollbackOk(const MethodContext& context ) = 0;

        virtual void selectOk(const MethodContext& context ) = 0;
    }; // class TxHandler
	
    // Method handler get methods

    virtual AMQP_ClientOperations::AccessHandler* getAccessHandler() = 0;
    virtual AMQP_ClientOperations::BasicHandler* getBasicHandler() = 0;
    virtual AMQP_ClientOperations::ChannelHandler* getChannelHandler() = 0;
    virtual AMQP_ClientOperations::ConnectionHandler* getConnectionHandler() = 0;
    virtual AMQP_ClientOperations::DtxHandler* getDtxHandler() = 0;
    virtual AMQP_ClientOperations::ExchangeHandler* getExchangeHandler() = 0;
    virtual AMQP_ClientOperations::FileHandler* getFileHandler() = 0;
    virtual AMQP_ClientOperations::MessageHandler* getMessageHandler() = 0;
    virtual AMQP_ClientOperations::QueueHandler* getQueueHandler() = 0;
    virtual AMQP_ClientOperations::StreamHandler* getStreamHandler() = 0;
    virtual AMQP_ClientOperations::TxHandler* getTxHandler() = 0;

}; /* class AMQP_ClientOperations */

} /* namespace framing */
} /* namespace qpid */

#endif
